<template lang="pug">
  .container-detail
    .icon.market-detail-icon-space-bottom
      Component(:is="`MarketSvg${detail.alias[0].toUpperCase()}${detail.alias.slice(1)}`")
    BaseText.title.market-detail-title-space-bottom(size='text-md') {{detail.rusAlias[0].toUpperCase() + detail.rusAlias.slice(1)}}
    BaseText.cost.market-detail-cost-space-bottom(size='text-md-small' skin='grey' weight='weight500') Стоимость: {{detail.cost}} монет
    BaseButton(
      size='small'
      skin='install'
      @click='install(detail)'
      :disabled='isNotEnoughtCoins(detail)'
    ) Установить
</template>

<script lang='ts'>
import { Vue, Component, Prop } from 'vue-property-decorator'
import { mapState } from 'vuex'

import { PurseModule } from '../../store/modules/purse/index'
import { ProductionModule } from '../../store/modules/production/index'
import IDetail from '../../store/modules/production/interfaces'
import BaseButton from '../BaseButton.vue'
import BaseText from '../BaseText.vue'
import MarketSvgBiomechanism from './MarketSvgBiomechanism.vue'
import MarketSvgProcessor from './MarketSvgProcessor.vue'
import MarketSvgSoul from './MarketSvgSoul.vue'

@Component({
  components: {
    BaseButton,
    BaseText,
    MarketSvgBiomechanism,
    MarketSvgProcessor,
    MarketSvgSoul
  }
})
export default class MarketDetail extends Vue {
  @Prop() detail!: IDetail

  get details () {
    return ProductionModule.details
  }

  get coins () {
    return PurseModule.coins
  }

  install (detail: IDetail) {
    PurseModule.subtractCoins(detail.cost)
    ProductionModule.install(detail.alias)
  }

  isNotEnoughtCoins (detail: IDetail) {
    return this.coins < detail.cost
  }
}
</script>

<style lang="scss" scoped>
@import '../../assets/styles/config/variables.scss';

.container-detail {
  width: 236px;
  display: flex;
  flex-direction: column;
  align-items: center;
}

.icon {
  width: 236px;
  height: 128px;
  filter: drop-shadow(0px 8px 90px $main-orange-color);
}
</style>
